package com.sundot.airport.system.service.portrait;

import com.sundot.airport.common.domain.portrait.BaseModuleIndicatorResult;
import com.sundot.airport.common.domain.portrait.IndicatorCalculateParams;
import com.sundot.airport.common.enums.portrait.IndicatorType;
import com.sundot.airport.common.enums.portrait.UserType;
import com.sundot.airport.common.service.portrait.Indicator;
import com.sundot.airport.system.domain.portrait.AdministrativePenaltyStats;
import com.sundot.airport.system.domain.portrait.IndicatorResult;
import com.sundot.airport.system.mapper.portrait.AdministrativePenaltyIndicatorMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Objects;

/**
 * 行政类处罚情况指标实现类
 */
@Component
public class AdministrativePenaltyIndicator implements Indicator<Object> {

    @Autowired
    private AdministrativePenaltyIndicatorMapper administrativePenaltyIndicatorMapper;

    private Object value;

    @Override
    public String getName() {
        return IndicatorType.ADMINISTRATIVE_PENALTY.getCode();
    }

    @Override
    public Object getValue() {
        return value;
    }

    @Override
    public void calculate(IndicatorCalculateParams params) {
        Long userId = params.getUserId();
        UserType userType = params.getUserType();
        List<Long> userIds = params.getUserIds();
        if (UserType.PERSONAL.equals(userType)) {
            // 个人行政类处罚情况
            this.value = administrativePenaltyIndicatorMapper.queryPersonalAdministrativePenaltyStatus(userId);
        } else {
            // 组织行政类处罚情况统计
            this.value = administrativePenaltyIndicatorMapper.queryOrgAdministrativePenaltyStats(userIds, userType);
        }
    }

    @Override
    public void setResult(BaseModuleIndicatorResult result) {
        if (result instanceof IndicatorResult) {
            IndicatorResult indicatorResult = (IndicatorResult) result;
            if (value instanceof String) {
                indicatorResult.setHasAdministrativePenalty((String) value);
            } else if (value instanceof AdministrativePenaltyStats) {
                indicatorResult.setAdministrativePenaltyStats((AdministrativePenaltyStats) value);
            }

        }
    }
}